# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..14\n"; }
END {print "not ok 1\n" unless $loaded;}
use Text::Template::YAWN;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

use Data::Dumper;

my $yawn=Text::Template::YAWN->new();

$yawn->add_text('', <<YAWN);
{define:hello world}

YAWN


#####################################################
my $q=$yawn->render('hello');
print 'not ' if $q ne 'world';
print "ok 2\n";


#####################################################
$q=$yawn->render('bizz');
print 'not ' if defined $q;
print "ok 3\n";


#####################################################
$yawn->add_text(" {define:bizz this is bizz} ");
$q=$yawn->render('bizz');
print 'not ' unless defined $q;
print "ok 4\n";


#####################################################
my $w="this isn't bizz";
$yawn->add_text("{define:bizz $w}");
$q=$yawn->render('bizz');
print 'not ' unless $q eq $w;
print "ok 5\n";

#####################################################
$w="something to work with";
$yawn->add_text("{define:bladder {define:billy $w} control}");
$q=$yawn->render('billy');
print 'not ' unless $q eq $w;
print "ok 6\n";

$q=$yawn->render('bladder');
print 'not ' unless $q eq ' control';
print "ok 7\n";



#####################################################
$yawn->add_text('bladder', " {billy}", 1);
$q=$yawn->render('bladder');
print 'not ' unless $q eq " control $w";
print "ok 8\n";


#####################################################
$yawn->set('billy', '{wimple {wooz} wiff}');
$q=$yawn->render('bladder');
print 'not ' unless $q eq " control ";
print "ok 9\n";

#####################################################
$yawn->set('wooz', 'windy');
$q=$yawn->render('bladder');
print 'not ' unless $q eq " control wimple windy wiff";
print "ok 10\n";

#####################################################
$yawn->delim('<{', '}>');
$yawn->load("zzzz.yawn") or die $@;
$q=$yawn->get('bladder');
print 'not ' if $q;
print "ok 11\n";

$q=$yawn->get('perpage');
print 'not ' unless $q and $q =~ /^Results per page/;
print "ok 12\n";

$q=$yawn->get('results');
print 'not ' unless $q and $q =~ /^Search found 0 pages.\s*$/;
# die Dumper $q, $yawn;
print "ok 13\n";

$q=$yawn->set(n=>20, start=>10, end=>15);
$q=$yawn->get('results');
print 'not ' unless $q and $q =~ /^Search found 20 pages.  Pages 10 to 15.$/;
print "ok 14\n";

# die Dumper $yawn;
